

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.11.3.1. scorer_tf_at_most &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.11.3.2. scorer_tf_idf" href="scorer_tf_idf.html" />
    <link rel="prev" title="7.11. スコアラー" href="../scorer.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/scorers/scorer_tf_at_most.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="scorer_tf_idf.html" title="7.11.3.2. scorer_tf_idf"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../scorer.html" title="7.11. スコアラー"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../scorer.html" accesskey="U"><span class="section-number">7.11. </span>スコアラー</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.11.3.1. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="scorer-tf-at-most">
<h1><span class="section-number">7.11.3.1. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code><a class="headerlink" href="#scorer-tf-at-most" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="admonition note">
<p class="admonition-title">注釈</p>
<p>スコアラーは実験的な機能です。</p>
</div>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 5.0.1 で追加.</span></p>
</div>
<div class="section" id="summary">
<h2><span class="section-number">7.11.3.1.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> はTF（term frequency。単語の出現数）ベースのスコアラーです。</p>
<p>TF-IDFベースのスコアラーを含むTFベースのスコアラーは次のケースに対して適していません。</p>
<p>文書中に「They are keyword, keyword, keyword ... and keyword」というように同じキーワードが大量に含まれているとその文書のスコアーが高くなってしまいます。これは意図した挙動ではありません。検索エンジンのスパマーはこのテクニックを使うかもしれません。</p>
<p><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> はTFベースのスコアラーですが、このケースを解決できます。</p>
<p><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> はスコアーの最大値を制限します。つまり、 <code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> は1つのマッチの影響を制限することができるということです。</p>
<p>文書中に「They are keyword, keyword, keyword ... and keyword」というように同じキーワードが大量に含まれていても、 <code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most(column,</span> <span class="pre">2.0)</span></code> はスコアーの値として大きくても <code class="docutils literal notranslate"><span class="pre">2</span></code> しか返しません。</p>
<blockquote id="note">
<div><p>スコアー関数だけでスコアの計算をする必要はありません。スコアー関数は検索クエリーに非常に依存しています。検索クエリーだけでなく、マッチしたレコードのメタデータも使えないか検討しましょう。</p>
<p>たとえば、Googleはスコアーの計算に <a class="reference external" href="https://ja.wikipedia.org/wiki/%E3%83%9A%E3%83%BC%E3%82%B8%E3%83%A9%E3%83%B3%E3%82%AF">ページランク</a> を使っています。あなたも、データの種類（たとえば、「メモ」データよりも「タイトル」データの方が重要など）、タグ、位置情報などを使えないか検討してみましょう。</p>
<p>スコアーの計算をスコアー関数だけで考えることはやめましょう。</p>
</div></blockquote>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.11.3.1.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このスコアラーの引数は2つです。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>scorer_tf_at_most(column, max)
scorer_tf_at_most(index, max)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.11.3.1.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このセクションではscorerの使い方について説明します。</p>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>サンプルスキーマ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Logs TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Logs message COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenBigram \
  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms message_index COLUMN_INDEX|WITH_POSITION Logs message
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>サンプルデータ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Logs
[
{&quot;message&quot;: &quot;Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice Notice Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice Notice Notice Notice&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 5]
</pre></div>
</div>
<p>次のように <a class="reference internal" href="../commands/select.html#select-match-columns"><span class="std std-ref">match_columns</span></a> で <code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> を指定します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Logs \
  --match_columns &quot;scorer_tf_at_most(message, 3.0)&quot; \
  --query &quot;Notice&quot; \
  --output_columns &quot;message, _score&quot; \
  --sort_keys &quot;-_score&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;message&quot;,
#           &quot;Text&quot;
#         ],
#         [
#           &quot;_score&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         &quot;Notice Notice Notice Notice Notice&quot;,
#         3
#       ],
#       [
#         &quot;Notice Notice Notice Notice&quot;,
#         3
#       ],
#       [
#         &quot;Notice Notice Notice&quot;,
#         3
#       ],
#       [
#         &quot;Notice Notice&quot;,
#         2
#       ],
#       [
#         &quot;Notice&quot;,
#         1
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>もし、文書が <code class="docutils literal notranslate"><span class="pre">Notice</span></code> という単語を3個以上含んでいたら、スコアーは <code class="docutils literal notranslate"><span class="pre">3</span></code> になります。なぜなら、この <code class="docutils literal notranslate"><span class="pre">select</span></code> ではスコアーの最大値を <code class="docutils literal notranslate"><span class="pre">3.0</span></code> と指定しているからです。</p>
<p>もし、文書が <code class="docutils literal notranslate"><span class="pre">Notice</span></code> という単語を1つか2つしか含んでいなかったら、スコアーは <code class="docutils literal notranslate"><span class="pre">1</span></code> か <code class="docutils literal notranslate"><span class="pre">2</span></code> になります。なぜなら、スコアーが指定された最大値 <code class="docutils literal notranslate"><span class="pre">3.0</span></code> より小さいからです。</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.11.3.1.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このセクションではすべての引数について説明します。</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.11.3.1.4.1. </span>必須引数<a class="headerlink" href="#required-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>必須の引数は1つです。</p>
<div class="section" id="column">
<h4><span class="section-number">7.11.3.1.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">column</span></code><a class="headerlink" href="#column" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>マッチ対象のデータカラムです。このデータカラムにはインデックスが張られていなければいけません。</p>
</div>
<div class="section" id="index">
<h4><span class="section-number">7.11.3.1.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">index</span></code><a class="headerlink" href="#index" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>検索に使うインデックスカラムです。</p>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.11.3.1.4.2. </span>省略可能引数<a class="headerlink" href="#optional-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>省略可能な引数はありません。</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.11.3.1.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このスコアラーは <a class="reference internal" href="../types.html#builtin-type-float"><span class="std std-ref">Float32</span></a> でスコアーの値を返します。</p>
<p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> は <code class="docutils literal notranslate"><span class="pre">Float</span></code> ではなく <code class="docutils literal notranslate"><span class="pre">Int32</span></code> で <code class="docutils literal notranslate"><span class="pre">_score</span></code> を返します。これは、後方互換性を維持するために <code class="docutils literal notranslate"><span class="pre">Float</span></code> から <code class="docutils literal notranslate"><span class="pre">Int32</span></code> にキャストしているためです。</p>
<p>スコアーは制限つきのTFで計算します。</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.11.3.1.6. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../scorer.html"><span class="doc">スコアラー</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.11.3.1. <code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.11.3.1.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.11.3.1.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.11.3.1.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.11.3.1.4. 引数</a><ul>
<li><a class="reference internal" href="#required-parameters">7.11.3.1.4.1. 必須引数</a><ul>
<li><a class="reference internal" href="#column">7.11.3.1.4.1.1. <code class="docutils literal notranslate"><span class="pre">column</span></code></a></li>
<li><a class="reference internal" href="#index">7.11.3.1.4.1.2. <code class="docutils literal notranslate"><span class="pre">index</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.11.3.1.4.2. 省略可能引数</a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.11.3.1.5. 戻り値</a></li>
<li><a class="reference internal" href="#see-also">7.11.3.1.6. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../scorer.html"
                        title="前の章へ"><span class="section-number">7.11. </span>スコアラー</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="scorer_tf_idf.html"
                        title="次の章へ"><span class="section-number">7.11.3.2. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_idf</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="scorer_tf_idf.html" title="7.11.3.2. scorer_tf_idf"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../scorer.html" title="7.11. スコアラー"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../scorer.html" ><span class="section-number">7.11. </span>スコアラー</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.11.3.1. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>